Subject: bug#17994: Linux RAID MBR type code

From: "Brian C. Lane" <[email-masked]>
Date: Mon, 14 Jul 2014 08:40:43 -0700

On Mon, Jul 14, 2014 at 10:03:58AM -0400, Phillip Susi wrote:
> On 7/13/2014 9:07 PM, Chris Murphy wrote:
> >> Why does it matter?  Linux doesn't pay attention to the
> >> partition type code anyhow.  I've always just used 0x83.
> > 
> > https://bugzilla.redhat.com/show_bug.cgi?id=1118065#c5 
> > https://bugzilla.redhat.com/show_bug.cgi?id=1118065#c8
> > 
> > 
> > I find this logic troubling. It's rather similar to the logic that 
> > lead to parted using the pre-existing Microsoft basic data GUID
> > when making Linux partitions on GPT disks; out of a pool of just
> > under infinite alternative GUIDs. "Oh it doesn't really matter" on
> > Linux, but meanwhile on dual boot systems, Windows recognizes its 
> > partitiontype GUID, but not the contents of the partition, and 
> > actively invites the user to reformat it.
> 
> How is this at all related?  Windows already ignores 0x83.
> 
> > For example, 0x83 partition type, and mdadm metadata 1.0 on md
> > raid1 suggests that the partition can be mounted stand alone rather
> > than first assembling the raid. If something actually were to do
> > this, the array would become inconsistent and unrepairable without
> > rather knowledgable manual intervention. A partition with md
> > metadata is in fact not a Linux filesystem, so really we shouldn't
> > lie about what it is by using the wrong partition type code.
> 
> Suggests?  Lieing?  To whom?  Nobody pays attention to the type codes.
>  Also if you really want a different type code for raid, there already
> is one: 0xFD.

It ends up that 0xFD is only supposed to be used for mdraid 0.9
metadata. For 1.0 and later they want 0xDA so that it isn't auto
assembled and gets ignored by everything else.

I've been meaning to write a patch to allow setting arbitrary values for
partition id / guid since it is a bit of a pain to add new flags every
time someone comes up with something new.

-- 
Brian C. Lane | Anaconda Team | IRC: bcl #anaconda | Port Orchard, WA (PST8PDT)